
package simula;

/**
 * The class SimulaException is fired whenever the code is unable to continue its work,
 * due either to standard java errors or to conceptual errors regarding simula.
 */
public class SimulaException extends Exception
{
	public static final String NO_CURRENT_PROCESS = "There is no current process.";
	public static final String PASSIVE_PROCESS = "A passive process has no scheduling time.";
	public static final String TERMINATED_PROCESS = "A terminated process has no scheduling time.";
	public static final String ACTIVATE_SCHEDULED = "Cannot activate a process that is already scheduled. Use 'reactivate'.";
	public static final String LINK_TO_NULL = "Cannot link to a null element.";
	public static final String PAST_TIME = "Cannot activate a process in the past or at current time. Use PRIOR clause with a future time.";
	public static final String ABNORMAL_INPUT = "Cannot parse the input correctly.";
	public static final String IO_EXCEPTION = "Cannot read an Int.";
	public static final String FIELD_TOO_SHORT = "The field lenght of an output was too short.";
	public static final String SENSELESS_PARAMETERS = "Meaningless parameters were provided.";
	public static final String MAIN_PASSIVATED = "Cannot passivate the simulation main process.";
	public static final String IDLE_PROCESS = "Cannot schedule before or after a passive process.";


	public SimulaException(String error) {
		super(error);
	}
}