
import simula.simset.simulation.*;
import simula.random.*;
import simula.*;

/**
 * Graphical UI templatre for Simulation with JSL 2.0
 * Method names and class structure are just hints. I' ve done it in this way,
 * but it is not the only way.
 * @author Andrea Poltronieri
 * @version 2.0 Feb 1998
 */

 /* Ususally extends Frame or applet*/
public class GUI implements java.util.Observer {
	private boolean interrupted = true ;
	Simulation sim = null ;


/**
 * Stop the eimulation and kill all active thread. Can't be used in an applet for security restrictions
 * Usually called by something like a "Stop" button
 */
public void interrupt ( ) {
	this.interrupted=true ;
	if (sim!=null) {
		try {
			sim.destroy() ;
		} catch (Exception e) {}
	}	
	sim=null ;
	return;
}

/**
 * Start the simulation 
 * @param The simulation parameters, read from user's input
 */
public void simulate() {
	try{
		this.interrupted=false ;
      /* Set the simulation parameters in a form like
         sim.XXX= YYY ;
      */
		sim = new examples.warehouse.WareHouseSimulation();
		sim.addObserver(this) ;
		ConcreteProcess main = new ConcreteProcess(sim);
	} catch (Exception e) { System.out.println("Exception caught: " + e);}	
	return;
}

/**
 * Called by observables (Simulation).
 * @param o Caller
 * @param arg Parameter. If the caller is a Simulation, arg is the active process
 */
public void update ( java.util.Observable o, Object arg) {
	if ((o==sim) && (sim !=null)) {
		/* Update result display */
		if ((sim.finished()) && !(interrupted)){
         /* Actions to be taken if the simulation reached the end 
            DO NOT try to destroy the simulation here, because this is the 
            thread of a simulation Process. A call to sim.destroy or sim.end will
            result in a system crash.
         */
		}	
	}	
		
	return;
}

}
